﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Security.Principal;

namespace WCFAuthorizationBehavior
{
    public class EBAuthorizationBehavior : ServiceAuthorizationManager
    {
        string _athorizedADGroup;
        public EBAuthorizationBehavior()
            : this(ConfigurationHelper.AllowedADGroupName)
        {

        }

        public EBAuthorizationBehavior(string authorizedADGroup)
        {
            _athorizedADGroup = authorizedADGroup;
        }

        public override bool CheckAccess(OperationContext operationContext)
        {
            return base.CheckAccess(operationContext);
        }

        public override bool CheckAccess(OperationContext operationContext, ref System.ServiceModel.Channels.Message message)
        {
            return base.CheckAccess(operationContext, ref message);
        }

        protected override bool CheckAccessCore(OperationContext operationContext)
        {
            try
            {
                //Getting SID from the GROUP Name
                SecurityIdentifier nAcc = new NTAccount(_athorizedADGroup).Translate(typeof(SecurityIdentifier)) as SecurityIdentifier;
                if (nAcc == null)
                    return false;
                else
                    return base.CheckAccessCore(operationContext) &&
                           operationContext.ServiceSecurityContext.WindowsIdentity.Groups.Contains(nAcc);//Additional verification to check for given AD group existence.
            }
            catch
            {
                return false;
            }
        }
    }
}
